<?php

/**
 * Nexi XPay Payment Module
 *
 * @author      iPlusService S.r.l. <asssistenza@iplusservice.it>
 * @category    Payment Module
 * @package     Nexi XPay
 * @version     4.0.0
 * @copyright   2017-2019 Nexi Payments S.p.A. (https://ecommerce.nexi.it)
 * @license     GNU General Public License v3.0
 */
class Iplusservice_XPay_Block_Payment_Redirect extends Mage_Payment_Block_Form
{

    protected function _construct()
    {
        parent::_construct();

        $this->setTemplate('iplusservice/xpay/payment/redirect.phtml');
    }

    public function availableMethodsExists()
    {
        return (count($this->getNexiAvailableMethods()) != 0);
    }

    public function getNexiAvailableMethods()
    {
        return $this->getMethod()->configuration->getAvailableMethods();
    }

    public function getLogo()
    {
        $timestamp = time() * 1000;

        $params = array(
            'apiKey' => $this->getMethod()->configuration->getAlias(),
            'timeStamp' => $timestamp,
            'platform' => 'magento',
            'platformVers' => '1.9',
            'pluginVers' => Mage::helper('iplusservice_xpay')->pluginVersion(),
            'mac' => sha1('apiKey=' . $this->getMethod()->configuration->getAlias() . 'timeStamp=' . $timestamp . $this->getMethod()->configuration->getMac())
        );

        return $this->getMethod()->configuration->getUrlLogo() . '?' . http_build_query($params);
    }

    public function getLogoStyle($methodCode)
    {
        $code = strtolower(trim($methodCode));

        $configuration = array(
            'maestro' => 'padding-left:10px; padding-top:6px; padding-bottom:6px;',
            'mastercard' => 'padding-left:10px; padding-top:6px; padding-bottom:6px;',
            'visa' => 'padding-left:10px; padding-top:9px; padding-bottom:9px;',
            'paypal' => 'padding-left:14px; padding-top:10px; padding-bottom:10px;',
            'sofort' => 'padding-left:15px; padding-top:8px; padding-bottom:8px;',
            'amazonpay' => 'padding-left:15px; padding-top:8px; padding-bottom:8px;',
            'googlepay' => 'padding-left:14px; padding-top:9px; padding-bottom:9px;',
            'alipay' => 'padding-left:10px; padding-top:0px; padding-bottom:0px;',
            'wechatpay' => 'padding-left:10px; padding-top:6px; padding-bottom:6px;',
            'masterpass' => 'padding-left:13px; padding-top:8px; padding-bottom:8px;',
            'applepay' => 'padding-left:15px; padding-top:8px; padding-bottom:8px;'
        );

        return array_key_exists($code, $configuration) ? $configuration[$code] : 'padding-left:14px; padding-top:8px; padding-bottom:8px;';
    }

}
