<?php

/**
 * Nexi XPay Payment Module
 *
 * @author      iPlusService S.r.l. <asssistenza@iplusservice.it>
 * @category    Payment Module
 * @package     Nexi XPay
 * @version     4.0.0
 * @copyright   2017-2019 Nexi Payments S.p.A. (https://ecommerce.nexi.it)
 * @license     GNU General Public License v3.0
 */
class Iplusservice_XPay_Model_Observer
{

    public function sectionPaymentChanged()
    {
        $paymentMethod = Mage::getModel('iplusservice_xpay/payment_redirect');

        $api = Mage::getModel('iplusservice_xpay/api', $paymentMethod->configuration);

        try {
            $result = $api->getAvailableMethods();
        } catch (Exception $ex) {
            error_log($ex->getMessage() . ' ' . $ex->getTraceAsString());

            $result = array(
                'urlLogo' => null,
                'availableMethods' => array()
            );
        }

        $cc = array();
        $apm = array();

        foreach ($result['availableMethods'] as $method) {
            if ($method['type'] === 'CC') {
                $cc[] = $method;
            } elseif ($method['type'] === 'APM') {
                $apm[] = $method;
            }
        }

        Mage::getModel('core/config')->saveConfig('payment/iplusservice_xpay/url_logo', $result['urlLogo']);
        Mage::getModel('core/config')->saveConfig('payment/iplusservice_xpay/available_methods', json_encode(array_merge($cc, $apm)));

        if (!$paymentMethod->configuration->getInstallationUniqueId()) {
            Mage::getModel('core/config')->saveConfig('payment/iplusservice_xpay/installation_unique_id', uniqid());

            Mage::app()->getConfig()->reinit();
        }
    }

}
